﻿using System;
using System.Drawing;
using Telerik.WinControls;
using Telerik.WinControls.UI;

namespace VirtualRadGridViewSortingFiltering.Core
{
    public class VirtualGridGroupPanelElement : GroupPanelElement
    {
        protected override Type ThemeEffectiveType
        {
            get
            {
                return typeof(GroupPanelElement);
            }
        }

        protected override bool ProcessDragOver(Point currentMouseLocation, ISupportDrag dragObject)
        {
            object context = dragObject.GetDataContext();

            if (context is GridViewColumn)
            {
                GridViewColumn column = dragObject.GetDataContext() as GridViewColumn;
                return column.CanDragToGroup();
            }
            else if (context is GroupFieldDragDropContext)
            {
                GroupFieldDragDropContext dragDropContext = context as GroupFieldDragDropContext;
                return dragDropContext.GroupDescription.GroupNames.Count > 1;
            }

            return false;
        }
    }
}